unit Circle;

interface

uses
  Graphics, Math, ExtCtrls;

type
TCircle=class
    private
      x, y, r: integer; // x,y,  r
      img:TImage;       // Image
      color:TColor;     // 
    public
      constructor Circle(imgsrc:TImage);overload;
      constructor Circle(imgsrc:TImage;c:TColor;ax,ay,ar:integer);overload;
      function GetX: integer;
      function GetY: integer;
      procedure SetR(ar: integer);
      procedure SetXY(ax,ay:integer);
      procedure Show;
      procedure MoveTo(ax,ay:integer);
      procedure Resize(ar:integer);
      procedure Delete;
end;

implementation

//    
constructor TCircle.Circle(imgsrc:TImage);
begin
  img:=imgsrc;
  x:=randomrange(100,img.Width-100);
  y:=randomrange(100,img.Height-100);
  r:=randomrange(10,100);
  color:=clRed;
end;

//    
constructor TCircle.Circle(imgsrc:TImage;c:TColor;ax,ay,ar:integer);
begin
  img:=imgsrc;
  x:=ax;
  y:=ay;
  r:=ar;
  color:=c;
end;

//.   x
function TCircle.GetX: integer;
begin
  result:=x;
end;

//.   y
function TCircle.GetY: integer;
begin
  result:=y;
end;

//.     x  y
procedure TCircle.SetXY(ax, ay: integer);
begin
  x:=ax;
  y:=ay;
end;

//.    r
procedure TCircle.SetR(ar:integer);
begin
  r:=ar;
end;

//.  
procedure TCircle.Show;
begin
  img.Canvas.Pen.Color:=color;
  img.Canvas.Ellipse(x-r, y-r, x+r, y+r);
end;

//.  
procedure TCircle.MoveTo(ax, ay: integer);
begin
  Show;
  x:=x+ax;
  y:=y+ay;
  Show;
end;

//.  
procedure TCircle.Resize(ar: integer);
begin
  Show;
  SetR(ar);
  Show;
end;

//.  
procedure TCircle.Delete;
begin
  Show;
  Free;
end;

end.
