unit Rectangle;

interface

uses
  Graphics, Math, ExtCtrls;

type
TRectangle=class
  private
    x, y, width, height: integer; // x,y,  width,  height
    img:TImage;                   // Image
    color:TColor;                 // 
  public
    constructor Rectangle(imgsrc:TImage);overload;
    constructor Rectangle(imgsrc:TImage;c:TColor;ax,ay,aw,ah:integer);overload;
    function GetX: integer;
    function GetY: integer;
    procedure SetAB(aw, ah: integer);
    procedure SetXY(ax, ay: integer);
    procedure Show;
    procedure MoveTo(ax, ay: integer);
    procedure Resize(aw, ah: integer);
    procedure Delete;
end;

implementation

//    
constructor TRectangle.Rectangle(imgsrc:TImage);
begin
  img:=imgsrc;
  x:=randomrange(25,img.Width-150);
  y:=randomrange(25,img.Height-150);
  width:=randomrange(50,125);
  height:=randomrange(50,125);
  color:=clBlue;
end;

//    
constructor TRectangle.Rectangle(imgsrc:TImage;c:TColor;ax,ay,aw,ah:integer);
begin
  x:=ax;
  y:=ay;
  width:=aw;
  height:=ah;
  color:=c;
end;

//.   x
function TRectangle.GetX: integer;
begin
  result:=x;
end;

//.   y
function TRectangle.GetY: integer;
begin
  result:=y;
end;

//.    
procedure TRectangle.SetAB(aw,ah:integer);
begin
  width:=aw;
  height:=ah;
end;

//.     
procedure TRectangle.SetXY(ax, ay: integer);
begin
  x:=ax;
  y:=ay;
end;

//.  
procedure TRectangle.Show();
begin
  img.Canvas.Pen.Color:=color;
  img.Canvas.Rectangle(x,y,x+width,y+height);
end;

//.  
procedure TRectangle.MoveTo(ax, ay: integer);
begin
  Show;
  SetXY(x+ax,y+ay);
  Show;
end;

//.  
procedure TRectangle.Resize(aw, ah: integer);
begin
  Show;
  width:=width+aw;
  if width<10 then
    width:=10;

  height:=height+ah;
  if height<10 then
    height:=10;
    
  SetAB(width,height);
  Show;
end;

//.  
procedure TRectangle.Delete;
begin
  Show;
  Free;
end;

end.
