unit Segment;

interface

uses
  Graphics, Math, ExtCtrls;


type
TSegment=class
  private
    x, y, length: integer;  // x,y,  length
    angle:real;             //  
    img:TImage;             // Image
    color:TColor;           // 
  public
    constructor Segment(imgsrc:TImage);overload;
    constructor Segment(imgsrc:TImage;c:TColor;ax,ay,al:integer;aa:real);overload;
    function GetX: integer;
    function GetY: integer;
    procedure SetAngle(aa:real);
    procedure SetLength(al:integer);
    procedure SetXY(ax,ay:integer);
    procedure Show;
    procedure MoveTo(ax,ay:integer);
    procedure Resize(al:integer);
    procedure Redirect(aa:real);
    procedure Resizedirect(al:integer;aa:real);
    procedure Delete;
end;

implementation

//    
constructor TSegment.Segment(imgsrc:TImage);
begin
  x:=randomrange(10,500);
  y:=randomrange(100,300);
  length:=randomrange(25,100);
  angle:=random(round(2*Pi));
  img:=imgsrc;
  color:=clGreen;
end;

//    
constructor TSegment.Segment(imgsrc:TImage;c:TColor;ax,ay,al:integer;aa:real);
begin
  x:=ax;
  y:=ay;
  length:=al;
  angle:=aa;
  img:=imgsrc;
  color:=c;
end;

//.   x
function TSegment.GetX: integer;
begin
  result:=x;
end;

//.   y
function TSegment.GetY: integer;
begin
  result:=y;
end;

//.  
procedure TSegment.SetAngle(aa:real);
begin
  angle:=aa;
end;

//.  
procedure TSegment.SetLength(al:integer);
begin
  length:=al;
end;

//.    x, y
procedure Tsegment.SetXY(ax, ay: integer);
begin
  x:=ax;
  y:=ay;
end;

//.  
procedure TSegment.Show();
begin
  img.Canvas.Pen.Color:=color;
  img.Canvas.MoveTo(x, y);
  img.Canvas.LineTo(x+round(length*(cos(angle))), y+round(length*(sin(angle))));
end;

//.  
procedure TSegment.MoveTo(ax, ay: integer);
begin
  Show;
  x:=x+ax;
  y:=y+ay;
  Show;
end;

//.   
procedure TSegment.Resize(al:integer);
begin
  Show;
  SetLength(al);
  Show;
end;

//.   
procedure TSegment.Redirect(aa:real);
begin
  Show;
  SetAngle(aa);
  Show;
end;

//.     
procedure TSegment.Resizedirect(al:integer;aa:real);
begin
  Show;
  SetLength(al);
  SetAngle(aa);
  Show;
end;

procedure TSegment.Delete;
begin
  Show;
  Free;
end;

end.
